/*

File: Config_Bits.h
Purpose: Configuration bits for PIC18F4550.
Compiler: MPLAB C18 v.3.22 Student Edition in MPLAB IDE v.8.15a.
Board: EasyPIC3 by Mikroelektronika.
January 2009.

*/
        #pragma config PLLDIV   = 2         	// PLL Prescaler Selection bits (8 MHz crystal on EasyPIC3 developer board)
        #pragma config CPUDIV   = OSC1_PLL2		// CPU System Clock Postscaler
        #pragma config USBDIV   = 2         	// USB Clock Selection bit (used in Full Speed USB mode only; Clock source from 96MHz PLL/2
        #pragma config FOSC     = HSPLL_HS		// Oscillator Selection bits
        #pragma config FCMEN    = OFF					// Fail-Safe Clock Monitor Enable bit
        #pragma config IESO     = OFF					// Internal/External Oscillator Switchover bit
        #pragma config PWRT     = OFF					// Power-up Timer Enable bit
        #pragma config BOR      = ON					// Brown-out Reset Enable bits
        #pragma config BORV     = 3						// Brown-out Voltage bits
        #pragma config VREGEN   = ON					// USB Voltage Regulator Enable bit
        #pragma config WDT      = OFF					// Watchdog Timer Enable bit
        #pragma config WDTPS    = 32768				// Watchdog Timer Postscale Select bits
        #pragma config MCLRE    = ON					// MCLR Pin Enable bit
        #pragma config LPT1OSC  = OFF					// Low-Power Timer 1 Oscillator Enable bit
        #pragma config PBADEN   = OFF					// PORTB A/D Enable bit
        #pragma config CCP2MX   = ON					// CCP2 MUX bit
        #pragma config STVREN   = OFF					// Stack Full/Underflow Reset Enable bit
        #pragma config LVP      = OFF					// Single-Supply ICSP Enable bit
        #pragma config ICPRT    = OFF       	// Dedicated In-Circuit Debug/Programming Port (ICPORT) Enable bit
        #pragma config XINST    = OFF       	// Extended Instruction Set Enable bit
        #pragma config DEBUG		= OFF					// Background Debugger Enable bit
        #pragma config CP0      = OFF					// Code Protection bit Block 0
        #pragma config CP1      = OFF					// Code Protection bit Block 1
        #pragma config CP2      = OFF					// Code Protection bit Block 2
        #pragma config CP3      = OFF					// Code Protection bit Block 3
        #pragma config CPB      = OFF					// Boot Block Code Protection bit
        #pragma config CPD      = OFF					// Data EEPROM Code Protection bit
        #pragma config WRT0     = OFF					// Write Protection bit Block 0
        #pragma config WRT1     = OFF					// Write Protection bit Block 1
        #pragma config WRT2     = OFF					// Write Protection bit Block 2
        #pragma config WRT3     = OFF					// Write Protection bit Block 3
        #pragma config WRTB     = OFF       	// Boot Block Write Protection
        #pragma config WRTC     = OFF					// Configuration Register Write Protection bit
        #pragma config WRTD     = OFF					// Data EEPROM Write Protection bit
        #pragma config EBTR0    = OFF					// Table Read Protection bit Block 0
        #pragma config EBTR1    = OFF					// Table Read Protection bit Block 1
        #pragma config EBTR2    = OFF					// Table Read Protection bit Block 2
        #pragma config EBTR3    = OFF					// Table Read Protection bit Block 3
        #pragma config EBTRB    = OFF					// Boot Block Table Read Protection
